% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tibble_methods.R
\name{as_tibble}
\alias{as_tibble}
\title{Coerce lists, matrices, and more to data frames}
\arguments{
\item{x}{A \code{SummarizedExperiment}}

\item{...}{This parameter includes \code{.subset} that can be set to any tidyselect expression. For example .subset = c(sample, type), or .subset = contains("PC").}
}
\value{
A tibble
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#maturing}{\figure{lifecycle-maturing.svg}{options: alt='[Maturing]'}}}{\strong{[Maturing]}}

\code{as_tibble()} turns a SummarizedExperiment existing object into a so-called tibble, a data frame with class \code{tbl_df}.
}
\examples{

tidySummarizedExperiment::pasilla \%>\%
    as_tibble()
    
tidySummarizedExperiment::pasilla \%>\%
    as_tibble(.subset = -c(condition, type))     
    
    
    
}
